package ru.flexfactory.view
{
	import flash.events.*;
	import flash.ui.Keyboard;
	
	import ru.flexfactory.controller.AppController;
	import ru.flexfactory.controller.operations.*;
	
	import spark.components.Button;

	public class AppMediator
	{
		private static var instance:AppMediator;
		
		private var app:Calculator;
		private var controller:AppController;

		public function AppMediator(app:Calculator)
		{
			this.app = app;
			controller = new AppController();
			
			setHandlers();
		}
		
		public static function startup(application:Calculator):void
		{
			if (instance == null) instance = new AppMediator(application);
		}
		
		private function setHandlers():void
		{
			var buttonArray:Array = [app.b0, app.b1, app.b2, app.b3, app.b4, 
									 app.b5, app.b6, app.b7, app.b8, app.b9];
			for each (var button:Button in buttonArray)
			{
				button.addEventListener(MouseEvent.CLICK, clickNumberHandler);
			}
			app.bDot.addEventListener(MouseEvent.CLICK, dotHandler);
			
			app.bC.addEventListener(MouseEvent.CLICK, clearHandler);
			app.bResult.addEventListener(MouseEvent.CLICK, resultHandler);
			
			app.bAdd.addEventListener(MouseEvent.CLICK, addHandler);
			app.bSub.addEventListener(MouseEvent.CLICK,subHandler);
			app.bMul.addEventListener(MouseEvent.CLICK, mulHandler);
			app.bDiv.addEventListener(MouseEvent.CLICK, divHandler);
			
			app.bNSign.addEventListener(MouseEvent.CLICK, nsignHandler);
			app.bSquare.addEventListener(MouseEvent.CLICK, squareHandler);
			app.bPersent.addEventListener(MouseEvent.CLICK, percentHandler);
			
			app.bMC.addEventListener(MouseEvent.CLICK, memoryClearHandler);
			app.bMR.addEventListener(MouseEvent.CLICK, memoryReadHandler);
			app.bMAdd.addEventListener(MouseEvent.CLICK, memoryAddHandler);
			app.bMSub.addEventListener(MouseEvent.CLICK, memorySubHandler);
			
			controller.addEventListener(AppController.OPERATOR_CHANGE, operatorChangeHandler);
		}
		
		protected function clickNumberHandler(event:MouseEvent):void
		{
			controller.pressNumericButton((event.currentTarget as Button).label);
		}
		
		protected function dotHandler(event:MouseEvent):void
		{
			controller.pressDotButton();
		}
		
		protected function clearHandler(event:MouseEvent):void
		{
			controller.clear();
		}
		
		protected function resultHandler(event:MouseEvent):void
		{
			controller.pressResultButton();
		}
		
		protected function addHandler(event:MouseEvent):void
		{
			controller.pressOperationButton(new AddOperation());
		}
		
		protected function subHandler(event:MouseEvent):void
		{
			controller.pressOperationButton(new SubOperation());
		}
		
		protected function mulHandler(event:MouseEvent):void
		{
			controller.pressOperationButton(new MulOperation());
		}
		
		protected function divHandler(event:MouseEvent):void
		{
			controller.pressOperationButton(new DivOperation());			
		}
		
		protected function nsignHandler(event:Event):void
		{
			controller.pressSignButton();			
		}
		
		protected function squareHandler(event:MouseEvent):void
		{
			controller.pressSquareButton();	
		}
		
		protected function percentHandler(event:MouseEvent):void
		{
			controller.pressPercentButton();			
		}
		
		protected function memoryClearHandler(event:MouseEvent):void
		{
			controller.pressMemoryClear();			
		}
		
		protected function memoryReadHandler(event:MouseEvent):void
		{
			controller.pressMemoryRead();			
		}
		
		protected function memoryAddHandler(event:MouseEvent):void
		{
			controller.pressMemoryAdd();			
		}
		
		protected function memorySubHandler(event:MouseEvent):void
		{
			controller.pressMemorySub();			
		}
		
		protected function operatorChangeHandler(event:Event):void
		{
			app.out.text = controller.displayValue;
			app.mem.text = controller.memoryState;
		}
	}
}